#include "GetKeys.h"

#ifdef GETKEY_NB
#define KEY_ENCODE
int GetKey_NB(unsigned int* key)	// Non-Breaking
{
	int kcode1 = 0;
	int kcode2 = 0;
	unsigned short unused;

	Bkey_GetKeyWait(&kcode1, &kcode2, KEYWAIT_HALTOFF_TIMEROFF, 0, !FALSE, &unused);
	*key = KeyEncode(kcode1, kcode2);
	Keyboard_ClrBuffer();

	return *key;
}
#endif // GETKEY_NB

#ifdef KEY_ENCODE
unsigned int KeyEncode(int kcode1, int kcode2)
{
	static const unsigned short KeyCodes[9][6] = {
		{ KEY_CTRL_F1,    KEY_CTRL_F2,     KEY_CTRL_F3,   KEY_CTRL_F4,     KEY_CTRL_F5,    KEY_CTRL_F6    },
		{ KEY_CTRL_SHIFT, KEY_CTRL_OPTN,   KEY_CTRL_VARS, KEY_CTRL_MENU,   KEY_CTRL_LEFT,  KEY_CTRL_UP    },
		{ KEY_CTRL_ALPHA, KEY_CHAR_SQUARE, KEY_CHAR_POW,  KEY_CTRL_EXIT,   KEY_CTRL_DOWN,  KEY_CTRL_RIGHT },
		{ KEY_CTRL_XTT,   KEY_CHAR_LOG,    KEY_CHAR_LN,   KEY_CHAR_SIN,    KEY_CHAR_COS,   KEY_CHAR_TAN   },
		{ KEY_CHAR_FRAC,  KEY_CTRL_FD,     KEY_CHAR_LPAR, KEY_CHAR_RPAR,   KEY_CHAR_COMMA, KEY_CHAR_STORE },
		{ KEY_CHAR_7,     KEY_CHAR_8,	   KEY_CHAR_9,    KEY_CTRL_DEL,    KEY_CTRL_NOP,   KEY_CTRL_NOP   },
		{ KEY_CHAR_4,     KEY_CHAR_5,	   KEY_CHAR_6,    KEY_CHAR_MULT,   KEY_CHAR_DIV,   KEY_CTRL_NOP   },
		{ KEY_CHAR_1,     KEY_CHAR_2,      KEY_CHAR_3,    KEY_CHAR_PLUS,   KEY_CHAR_MINUS, KEY_CTRL_NOP   },
		{ KEY_CHAR_0,     KEY_CHAR_DP,     KEY_CHAR_EXP,  KEY_CHAR_PMINUS, KEY_CTRL_EXE,   KEY_CTRL_NOP   }
	};

	if (kcode1 < 2 || kcode2 < 2 || kcode1 > 7 || kcode2 > 10)
		return kcode1 == 1 && kcode2 == 1 ? (unsigned int)KEY_CTRL_AC : (unsigned int)KEY_CTRL_NOP;

	return (unsigned int)KeyCodes[10 - kcode2][7 - kcode1];
}
#endif // KEYENCODE

/* int CheckKeyRow(int row) {
	int result = 0;
	short* PORTB_CTRL = (void*)0xA4000102;
	short* PORTM_CTRL = (void*)0xA4000118;
	char* PORTB = (void*)0xA4000122;
	char* PORTM = (void*)0xA4000138;
	char* PORTA = (void*)0xA4000120;
	short smask = 0x0003 << ((row % 8) << 1);
	char cmask = ~(1 << (row % 8));
	char PORTBtmp = *PORTB;
	char PORTMtmp = *PORTM;

	if (row < 8) {
		// configure port B as input, except for the "row to check"-bit, which has to be an output.
		*PORTB_CTRL = 0xAAAA ^ smask;
		// configure port M as input; port M is inactive with row < 8
		*PORTM_CTRL = (*PORTM_CTRL & 0xFF00) | 0x00AA;
		*PORTB = cmask;    // set the "row to check"-bit to 0 on port B
		*PORTM = (*PORTM & 0xF0) | 0x0F;    // port M is inactive with row < 8
	}
	else {
		*PORTB_CTRL = 0xAAAA;  // configure port B as input; port B is inactive with row >= 8
// configure port M as input, except for the "row to check"-bit, which has to be an output.
		*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00) | 0x00AA) ^ smask;
		*PORTB = 0xFF;    // port B is inactive with row >= 8 (all to 1)
		*PORTM = (*PORTM & 0xF0) | cmask;  // set the "row to check"-bit to 0
	};
	result = ~(*PORTA);   // a pressed key in the row-to-check draws the corresponding bit to 0
	//  *PORTB_CTRL = 0xAAAA;  
	//  *PORTM_CTRL = (*PORTM_CTRL & 0xFF00 ) | 0x00AA;
	//  delay(wait);
	*PORTB_CTRL = 0x5555;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00) | 0x0055;
	*PORTB = PORTBtmp;
	*PORTM = PORTMtmp;
	return result;
} */

#ifdef GET_KEY
unsigned int Get_Key()
{
	char OS[10];
	volatile char *KEYSC = (void *)0xA44B0000;
	unsigned int key = 64;
	int i;
	// const unsigned char MultiplyDeBruijnBitPosition2[32] = {
	// 	0,  1,  28, 2,  29, 14, 24, 3, 30, 22, 20, 15, 25, 17, 4,  8,
	// 	31, 27, 13, 23, 21, 19, 16, 7, 26, 12, 18, 6,  11, 5,  10, 9
	// };
	const unsigned char MultiplyDeBruijnBitPosition2[32] = {
		0, 2, 0, 3, 0, 0, 0, 4, 0, 0, 0, 0, 0, 0, 5, 9,
		0, 0, 0, 0, 0, 0, 0, 8, 0, 0, 0, 7, 0, 6, 0, 0
	};
	unsigned char string[33];

	System_GetOSVersion(OS);

	if (OS[9] == '0')
		return 0;

	for (i = 9; i > 0; i--)
	{
		key = (unsigned int)KEYSC[i ^ 1];
		if (key)
			break;
	}

	// sprintf((char *)string, "%u         ", key);
	// PrintMini(60, 12, string, 0);
	// sprintf((char *)string, "%X         ", -key);
	// PrintMini(60, 18, string, 0);
	key &= -key;
	// sprintf((char *)string, "%u         ", key);
	// PrintMini(60, 24, string, 0);
	key = (unsigned int)(key * 0x077CB531U) >> 27;
	// sprintf((char *)string, "%u         ", key);
	// PrintMini(60, 30, string, 0);
	key = MultiplyDeBruijnBitPosition2[key];
	// sprintf((char *)string, "%u         ", key);
	// PrintMini(60, 36, string, 0);

	return 10 * key + i;
}
#endif

int CheckKey(unsigned char col, unsigned char row) {
	unsigned char result;
	short* PORTB_CTRL = (void*)0xA4000102;
	short* PORTM_CTRL = (void*)0xA4000118;
	char* PORTA = (void*)0xA4000120;
	char* PORTB = (void*)0xA4000122;
	char* PORTM = (void*)0xA4000138;
	unsigned char rowMod8 = row & 7;
	short smask = 3 << (rowMod8 << 1);
	char cmask = ~(1 << rowMod8);
	char PORTB_Backup = *PORTB;
	char PORTM_Backup = *PORTM;
	if (row < 8) {
		*PORTB_CTRL = 0xAAAA ^ smask;
		*PORTM_CTRL = (*PORTM_CTRL & 0xFF00) | 0x00AA;
		*PORTB = cmask;
		*PORTM = (*PORTM & 0xF0) | 0x0F;
	}
	else {
		*PORTB_CTRL = 0xAAAA;
		*PORTM_CTRL = ((*PORTM_CTRL & 0xFF00) | 0x00AA) ^ smask;
		*PORTB = 0xFF;
		*PORTM = (*PORTM & 0xF0) | cmask;
	}
	result = (~(*PORTA)) >> col & 1;
	*PORTB_CTRL = 0xAAAA;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00) | 0x00AA;
	*PORTB_CTRL = 0x5555;
	*PORTM_CTRL = (*PORTM_CTRL & 0xFF00) | 0x0055;
	*PORTB = PORTB_Backup;
	*PORTM = PORTM_Backup;
	return result;
}

int scanKeyboard(int col, int row) {
	char OS[10];
	volatile char* KEYSC;

	System_GetOSVersion(OS);

	if (OS[9] == '0')
		return CheckKey(col, row);

	KEYSC = (void*)0xA44B0000;
	return (((unsigned int)KEYSC[row ^ 1]) >> col) & 1;
}

#ifdef KEY_ENCODE_OLD
unsigned int KeyEncode_old(int kcode1, int kcode2) {
	static const unsigned short KeyCodes[6][9] = {
		{ KEY_CTRL_NOP,	   KEY_CTRL_NOP,   KEY_CTRL_NOP,  KEY_CTRL_NOP, KEY_CHAR_STORE, KEY_CHAR_TAN, KEY_CTRL_RIGHT,  KEY_CTRL_UP,	   KEY_CTRL_F6 },
		{ KEY_CTRL_EXE,	   KEY_CHAR_MINUS, KEY_CHAR_DIV,  KEY_CTRL_NOP, KEY_CHAR_COMMA, KEY_CHAR_COS, KEY_CTRL_DOWN,   KEY_CTRL_LEFT,  KEY_CTRL_F5 },
		{ KEY_CHAR_PMINUS, KEY_CHAR_PLUS,  KEY_CHAR_MULT, KEY_CTRL_DEL, KEY_CHAR_RPAR,  KEY_CHAR_SIN, KEY_CTRL_EXIT,   KEY_CTRL_MENU,  KEY_CTRL_F4 },
		{ KEY_CHAR_EXP,	   KEY_CHAR_3,	   KEY_CHAR_6,	  KEY_CHAR_9,   KEY_CHAR_LPAR,  KEY_CHAR_LN,  KEY_CHAR_POW,	   KEY_CTRL_VARS,  KEY_CTRL_F3 },
		{ KEY_CHAR_DP,	   KEY_CHAR_2,	   KEY_CHAR_5,	  KEY_CHAR_8,   KEY_CTRL_FD,	KEY_CHAR_LOG, KEY_CHAR_SQUARE, KEY_CTRL_OPTN,  KEY_CTRL_F2 },
		{ KEY_CHAR_0,	   KEY_CHAR_1,	   KEY_CHAR_4,	  KEY_CHAR_7,   KEY_CHAR_FRAC,  KEY_CTRL_XTT, KEY_CTRL_ALPHA,  KEY_CTRL_SHIFT, KEY_CTRL_F1 }
	};

	if (kcode1 < 2 || kcode2 < 2 || kcode1 > 7 || kcode2 > 10)
		return kcode1 == 1 && kcode2 == 1 ? KEY_CTRL_AC : KEY_CTRL_NOP;

	return KeyCodes[kcode1 - 2][kcode2 - 2];
}
#endif // KEYENCODE

#ifdef KEY_DECODE
int KeyDecode(int key, int* kcode1, int* kcode2, char* modifier)
{
	short kcode;
	static const unsigned char KeyCodes[309] = {
	//	0,			1,			2,			3,			4,			5,			6,			7,			8,			9,			A,			B,			C,			D,			E,			F,
		0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			KEY_CR,		KEY_STORE,	KEY_EXP,	
		0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			
		KEY_SPACE,	0,			KEY_DQUATE,	0,			0,			0,			0,			0,			KEY_LPAR,	KEY_RPAR,	0,			0,			KEY_COMMA,	0,			KEY_DP,		0,			
		KEY_0,		KEY_1,		KEY_2,		KEY_3,		KEY_4,		KEY_5,		KEY_6,		KEY_7,		KEY_8,		KEY_9,		0,			0,			0,			KEY_EQUAL,	0,			0,			
		0,			KEY_A,		KEY_B,		KEY_C,		KEY_D,		KEY_E,		KEY_F,		KEY_G,		KEY_H,		KEY_I,		KEY_J,		KEY_K,		KEY_L,		KEY_M,		KEY_N,		KEY_O,		
		KEY_P,		KEY_Q,		KEY_R,		KEY_S,		KEY_T,		KEY_U,		KEY_V,		KEY_W,		KEY_X,		KEY_Y,		KEY_Z,		KEY_LBRCKT,	0,			KEY_RBRCKT,	0,			0,			
		0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			
		0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			KEY_LBRACE,	0,			KEY_RBRACE,	0,			0,			
		0,			KEY_SIN,	KEY_COS,	KEY_TAN,	0,			KEY_LN,		KEY_ROOT,	KEY_PMINUS,	0,			KEY_PLUS,	0,			KEY_SQUARE,	0,			0,			0,			0,			
		0,			KEY_ASIN,	KEY_ACOS,	KEY_ATAN,	0,			KEY_LOG,	KEY_CUBEROOT,0,			0,			KEY_MINUS,	0,			KEY_RECIP,	0,			0,			0,			0,			
		0,			0,			0,			0,			0,			KEY_EXPN,	0,			0,			KEY_POW,	KEY_MULT,	0,			0,			0,			0,			0,			0,			
		0,			0,			0,			0,			0,			KEY_EXPN10,	0,			0,			KEY_POWROOT,KEY_DIV,	0,			KEY_FRAC,	0,			0,			0,			0,			
		KEY_ANS,	0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			KEY_VALR,	KEY_THETA,	0,			
		KEY_PI,		KEY_XTT,	KEY_EXIT,	KEY_MENU,	KEY_EXE,	0,			KEY_SHIFT,	KEY_ALPHA,	KEY_OPTN,	KEY_F1,		KEY_F2,		KEY_F3,		KEY_F4,		KEY_F5,		KEY_F6,		KEY_AC,
		KEY_VARS,	0,			KEY_UP,		0,			KEY_LEFT,	KEY_RIGHT,	0,			KEY_DOWN,	0,			KEY_DEL,	KEY_FRACCNVRT,0,		KEY_PRGM,	KEY_QUIT,	0,			0,
		0,			KEY_INS,	0,			0,			KEY_PASTE,	KEY_SETUP,	0,			0,			0,			0,			0,			0,			0,			0,			KEY_FD,		0,
		0,			0,			KEY_CLIP,	0,			KEY_PAGEUP,	KEY_PAGEDOWN,KEY_MIXEDFRAC,KEY_CAPTURE,0,		0,			0,			0,			0,			0,			0,			0,
		0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,
		0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,			0,
		0,			0,			0,			0,			KEY_CATALOG
	};

	//static const unsigned char KeyCodes[256] = {
	////	0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F,
	//	0,0,0,0,0,0,0,0,0,0,0,0,0,KEY_CHAR_CR,KEY_CHAR_STORE,KEY_CHAR_EXP,
	//	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//	KEY_CHAR_SPACE,0,KEY_CHAR_DQUATE,0,0,0,0,0,KEY_CHAR_LPAR,KEY_CHAR_RPAR,0,0,KEY_CHAR_COMMA,0,KEY_CHAR_DP,0,
	//	KEY_CHAR_0,KEY_CHAR_1,KEY_CHAR_2,KEY_CHAR_3,KEY_CHAR_4,KEY_CHAR_5,KEY_CHAR_6,KEY_CHAR_7,KEY_CHAR_8,KEY_CHAR_9,0,0,0,KEY_CHAR_EQUAL,0,0,
	//	0,KEY_CHAR_A,KEY_CHAR_B,KEY_CHAR_C,KEY_CHAR_D,KEY_CHAR_E,KEY_CHAR_F,KEY_CHAR_G,KEY_CHAR_H,KEY_CHAR_I,KEY_CHAR_J,KEY_CHAR_K,KEY_CHAR_L,KEY_CHAR_M,KEY_CHAR_N,KEY_CHAR_O,
	//	KEY_CHAR_P,KEY_CHAR_Q,KEY_CHAR_R,KEY_CHAR_S,KEY_CHAR_T,KEY_CHAR_U,KEY_CHAR_V,KEY_CHAR_W,KEY_CHAR_X,KEY_CHAR_Y,KEY_CHAR_Z,KEY_CHAR_LBRCKT,0,KEY_CHAR_RBRCKT,0,0,
	//	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//	0,0,0,0,0,0,0,0,0,0,0,KEY_CHAR_LBRACE,0,KEY_CHAR_RBRACE,0,0,
	//	0,KEY_CHAR_SIN,KEY_CHAR_COS,KEY_CHAR_TAN,0,KEY_CHAR_LN,KEY_CHAR_ROOT,KEY_CHAR_PMINUS,0,KEY_CHAR_PLUS,0,KEY_CHAR_SQUARE,0,0,0,0,
	//	0,KEY_CHAR_ASIN,KEY_CHAR_ACOS,KEY_CHAR_ATAN,0,KEY_CHAR_LOG,KEY_CHAR_CUBEROOT,0,0,KEY_CHAR_MINUS,0,KEY_CHAR_RECIP,0,0,0,0,
	//	0,0,0,0,0,KEY_CHAR_EXPN,0,0,KEY_CHAR_POW,KEY_CHAR_MULT,0,0,0,0,0,0,
	//	0,0,0,0,0,KEY_CHAR_EXPN10,0,0,KEY_CHAR_POWROOT,KEY_CHAR_DIV,0,KEY_CHAR_FRAC,0,0,0,0,
	//	KEY_CHAR_ANS,0,0,0,0,0,0,0,0,0,0,0,0,KEY_CHAR_VALR,KEY_CHAR_THETA,0,
	//	KEY_CHAR_PI,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	//};
		
	/*
				   1111
			   11010000
		111111101000000
		111010100110000
	*/
		
	if (key < 0) {
		*kcode1 = KEY_NOP;
		*kcode2 = KEY_NOP;
		*modifier = KEY_NOP;
		return KEY_CTRL_NOP;
	}
	*kcode1 = KeyCodes[key] / 10;
	*kcode2 = KeyCodes[key] % 10;
	*modifier = KeyCodes[key];
	return (unsigned int)(KeyCodes[key]);
}
#endif // KEYDECODE

//static const unsigned short KeyCodes[9][9] = {
//	{ KEY_CTRL_F1,	  KEY_CTRL_F2,     KEY_CTRL_F3,   KEY_CTRL_F4,     KEY_CTRL_F5,    KEY_CTRL_F6    },
//	{ KEY_CTRL_SHIFT, KEY_CTRL_OPTN,   KEY_CTRL_VARS, KEY_CTRL_MENU,   KEY_CTRL_LEFT,  KEY_CTRL_UP    },
//	{ KEY_CTRL_ALPHA, KEY_CHAR_SQUARE, KEY_CHAR_POW,  KEY_CTRL_EXIT,   KEY_CTRL_DOWN,  KEY_CTRL_RIGHT },
//	{ KEY_CTRL_XTT,	  KEY_CHAR_LOG,    KEY_CHAR_LN,   KEY_CHAR_SIN,    KEY_CHAR_COS,   KEY_CHAR_TAN   },
//	{ KEY_CHAR_FRAC,  KEY_CTRL_FD,     KEY_CHAR_LPAR, KEY_CHAR_RPAR,   KEY_CHAR_COMMA, KEY_CHAR_STORE },
//	{ KEY_CHAR_7,	  KEY_CHAR_8,	   KEY_CHAR_9,    KEY_CTRL_DEL,    KEY_CTRL_NOP,   KEY_CTRL_NOP   },
//	{ KEY_CHAR_4,     KEY_CHAR_5,	   KEY_CHAR_6,    KEY_CHAR_MULT,   KEY_CHAR_DIV,   KEY_CTRL_NOP   },
//	{ KEY_CHAR_1,     KEY_CHAR_2,      KEY_CHAR_3,    KEY_CHAR_PLUS,   KEY_CHAR_MINUS, KEY_CTRL_NOP   },
//	{ KEY_CHAR_0,     KEY_CHAR_DP,     KEY_CHAR_EXP,  KEY_CHAR_PMINUS, KEY_CTRL_EXE,   KEY_CTRL_NOP   }
//
//	{ KEY_CTRL_NOP,	   KEY_CTRL_NOP,   KEY_CTRL_NOP,  KEY_CTRL_NOP, KEY_CHAR_STORE, KEY_CHAR_TAN, KEY_CTRL_RIGHT,  KEY_CTRL_UP,    KEY_CTRL_F6 },
//	{ KEY_CTRL_EXE,	   KEY_CHAR_MINUS, KEY_CHAR_DIV,  KEY_CTRL_NOP, KEY_CHAR_COMMA, KEY_CHAR_COS, KEY_CTRL_DOWN,   KEY_CTRL_LEFT,  KEY_CTRL_F5 },
//	{ KEY_CHAR_PMINUS, KEY_CHAR_PLUS,  KEY_CHAR_MULT, KEY_CTRL_DEL, KEY_CHAR_RPAR,  KEY_CHAR_SIN, KEY_CTRL_EXIT,   KEY_CTRL_MENU,  KEY_CTRL_F4 },
//	{ KEY_CHAR_EXP,	   KEY_CHAR_3,	   KEY_CHAR_6,	  KEY_CHAR_9,   KEY_CHAR_LPAR,  KEY_CHAR_LN,  KEY_CHAR_POW,	   KEY_CTRL_VARS,  KEY_CTRL_F3 },
//	{ KEY_CHAR_DP,	   KEY_CHAR_2,	   KEY_CHAR_5,	  KEY_CHAR_8,   KEY_CTRL_FD,	KEY_CHAR_LOG, KEY_CHAR_SQUARE, KEY_CTRL_OPTN,  KEY_CTRL_F2 },
//	{ KEY_CHAR_0,	   KEY_CHAR_1,	   KEY_CHAR_4,	  KEY_CHAR_7,   KEY_CHAR_FRAC,  KEY_CTRL_XTT, KEY_CTRL_ALPHA,  KEY_CTRL_SHIFT, KEY_CTRL_F1 }
//};

/*
#define KEY_CTRL_NOP        0x00
#define KEY_CHAR_CR         0x0d
#define KEY_CHAR_STORE      0x0e
#define KEY_CHAR_EXP        0x0f
#define KEY_CHAR_SPACE      0x20
#define KEY_CHAR_DQUATE     0x22
#define KEY_CHAR_LPAR       0x28
#define KEY_CHAR_RPAR       0x29
#define KEY_CHAR_COMMA      0x2c
#define KEY_CHAR_DP         0x2e
#define KEY_CHAR_0          0x30
#define KEY_CHAR_1          0x31
#define KEY_CHAR_2          0x32
#define KEY_CHAR_3          0x33
#define KEY_CHAR_4          0x34
#define KEY_CHAR_5          0x35
#define KEY_CHAR_6          0x36
#define KEY_CHAR_7          0x37
#define KEY_CHAR_8          0x38
#define KEY_CHAR_9          0x39
#define KEY_CHAR_EQUAL      0x3d
#define KEY_CHAR_A          0x41
#define KEY_CHAR_B          0x42
#define KEY_CHAR_C          0x43
#define KEY_CHAR_D          0x44
#define KEY_CHAR_E          0x45
#define KEY_CHAR_F          0x46
#define KEY_CHAR_G          0x47
#define KEY_CHAR_H          0x48
#define KEY_CHAR_I          0x49
#define KEY_CHAR_J          0x4a
#define KEY_CHAR_K          0x4b
#define KEY_CHAR_L          0x4c
#define KEY_CHAR_M          0x4d
#define KEY_CHAR_N          0x4e
#define KEY_CHAR_O          0x4f
#define KEY_CHAR_P          0x50
#define KEY_CHAR_Q          0x51
#define KEY_CHAR_R          0x52
#define KEY_CHAR_S          0x53
#define KEY_CHAR_T          0x54
#define KEY_CHAR_U          0x55
#define KEY_CHAR_V          0x56
#define KEY_CHAR_W          0x57
#define KEY_CHAR_X          0x58
#define KEY_CHAR_Y          0x59
#define KEY_CHAR_Z          0x5a
#define KEY_CHAR_LBRCKT     0x5b
#define KEY_CHAR_RBRCKT     0x5d
#define KEY_CHAR_LBRACE     0x7b
#define KEY_CHAR_RBRACE     0x7d
#define KEY_CHAR_SIN        0x81
#define KEY_CHAR_COS        0x82
#define KEY_CHAR_TAN        0x83
#define KEY_CHAR_LN         0x85
#define KEY_CHAR_ROOT       0x86
#define KEY_CHAR_PMINUS     0x87
#define KEY_CHAR_PLUS       0x89
#define KEY_CHAR_SQUARE     0x8b
#define KEY_CHAR_ASIN       0x91
#define KEY_CHAR_ACOS       0x92
#define KEY_CHAR_ATAN       0x93
#define KEY_CHAR_LOG        0x95
#define KEY_CHAR_CUBEROOT   0x96
#define KEY_CHAR_MINUS      0x99
#define KEY_CHAR_RECIP      0x9b
#define KEY_CHAR_EXPN       0xa5
#define KEY_CHAR_POW        0xa8
#define KEY_CHAR_MULT       0xa9
#define KEY_CHAR_EXPN10     0xb5
#define KEY_CHAR_POWROOT    0xb8
#define KEY_CHAR_DIV        0xb9
#define KEY_CHAR_FRAC       0xbb
#define KEY_CHAR_ANS        0xc0
#define KEY_CHAR_VALR       0xcd
#define KEY_CHAR_THETA      0xce
#define KEY_CHAR_PI         0xd0
*/
/*
#define KEY_CTRL_XTT        0x7531
#define KEY_CTRL_EXIT       0x7532
#define KEY_CTRL_MENU       0x7533
#define KEY_CTRL_EXE        0x7534	-
#define KEY_CTRL_SHIFT      0x7536
#define KEY_CTRL_ALPHA      0x7537
#define KEY_CTRL_OPTN       0x7538
#define KEY_CTRL_F1         0x7539	-
#define KEY_CTRL_F2         0x753A
#define KEY_CTRL_F3         0x753B
#define KEY_CTRL_F4         0x753C
#define KEY_CTRL_F5         0x753D
#define KEY_CTRL_F6         0x753E
#define KEY_CTRL_AC         0x753F
#define KEY_CTRL_VARS       0x7540
#define KEY_CTRL_UP         0x7541	-
#define KEY_CTRL_LEFT       0x7544
#define KEY_CTRL_RIGHT      0x7545	-
#define KEY_CTRL_DOWN       0x7547
#define KEY_CTRL_DEL        0x7548
#define KEY_CTRL_FRACCNVRT  0x7549	-
#define KEY_CTRL_PRGM       0x754B
#define KEY_CTRL_QUIT       0x754C	-
#define KEY_CTRL_INS        0x7551	-
#define KEY_CTRL_PASTE      0x7554
#define KEY_CTRL_SETUP      0x7555	-
#define KEY_CTRL_FD         0x755E	-
#define KEY_CTRL_CLIP       0x7562	-
#define KEY_CTRL_PAGEUP     0x7564
#define KEY_CTRL_PAGEDOWN   0x7565
#define KEY_CTRL_MIXEDFRAC  0x7566
#define KEY_CTRL_CAPTURE    0x7567	-
#define	KEY_CTRL_RESERVE1	0x756C
#define	KEY_CTRL_RESERVE2	0x756D
#define	KEY_CTRL_RESERVE3	0x756E	-
#define KEY_CTRL_CATALOG    0x7594
*/
/*
#define KEY_CHAR_IMGNRY     0x7F50
#define KEY_CHAR_LIST       0x7F51
#define KEY_CHAR_MAT        0x7F40
#define KEY_CHAR_ANGLE      0x7F54
*/

/*
0	KEY_CHAR_0			KEY_CHAR_IMGNRY		KEY_CHAR_Z
1	KEY_CHAR_1			KEY_CHAR_LIST		KEY_CHAR_U
2	KEY_CHAR_2			KEY_CHAR_MAT		KEY_CHAR_V
3	KEY_CHAR_3			KEY_CHAR_W
4	KEY_CHAR_4			KEY_CTRL_CATALOG	KEY_CHAR_P
5	KEY_CHAR_5			KEY_CHAR_Q
6	KEY_CHAR_6			KEY_CHAR_R
7	KEY_CHAR_7			KEY_CTRL_CAPTURE	KEY_CHAR_M
8	KEY_CHAR_8			KEY_CTRL_CLIP		KEY_CHAR_N
9	KEY_CHAR_9			KEY_CTRL_PASTE		KEY_CHAR_O
.	KEY_CHAR_DP			KEY_CHAR_EQUAL		KEY_CHAR_SPACE
c	KEY_CHAR_EXP		KEY_CHAR_PI			KEY_CHAR_DQUATE
n	KEY_CHAR_PMINUS		KEY_CHAR_ANS
+	KEY_CHAR_PLUS		KEY_CHAR_LBRCKT		KEY_CHAR_X
-	KEY_CHAR_MINUS		KEY_CHAR_RBRCKT		KEY_CHAR_Y
m	KEY_CHAR_MULT		KEY_CHAR_LBRACE		KEY_CHAR_S
M	KEY_CHAR_DIV		KEY_CHAR_RBRACE		KEY_CHAR_T
l	KEY_CTRL_EXE		KEY_CHAR_CR
P	KEY_CTRL_DEL		KEY_CTRL_INS
O	KEY_CTRL_AC
z	KEY_CHAR_FRAC		KEY_CTRL_MIXEDFRAC	KEY_CHAR_G
x	KEY_CTRL_FD			KEY_CTRL_FRACCNVRT	KEY_CHAR_H
(	KEY_CHAR_LPAR		KEY_CHAR_CUBEROOT	KEY_CHAR_I
)	KEY_CHAR_RPAR		KEY_CHAR_RECIP		KEY_CHAR_J
,	KEY_CHAR_COMMA		KEY_CHAR_K
b	KEY_CHAR_STORE		KEY_CHAR_L
f	KEY_CTRL_XTT		KEY_CHAR_ANGLE		KEY_CHAR_A
g	KEY_CHAR_LOG		KEY_CHAR_EXPN10		KEY_CHAR_B
G	KEY_CHAR_LN			KEY_CHAR_EXPN		KEY_CHAR_C
h	KEY_CHAR_SIN		KEY_CHAR_ASIN		KEY_CHAR_D
j	KEY_CHAR_COS		KEY_CHAR_ACOS		KEY_CHAR_E
k	KEY_CHAR_TAN		KEY_CHAR_ATAN		KEY_CHAR_F
s	KEY_CHAR_SQUARE		KEY_CHAR_ROOT		KEY_CHAR_VALR
^	KEY_CHAR_POW		KEY_CHAR_POWROOT	KEY_CHAR_THETA
E	KEY_CTRL_EXIT		KEY_CTRL_QUIT		KEY_CTRL_EXIT
S	KEY_CTRL_SHIFT		KEY_CTRL_SHIFT		KEY_CTRL_SHIFT
A	KEY_CTRL_ALPHA		KEY_CTRL_ALPHA		KEY_CTRL_ALPHA
O	KEY_CTRL_OPTN
V	KEY_CTRL_VARS		KEY_CTRL_PRGM
M	KEY_CTRL_MENU		KEY_CTRL_SETUP
/\	KEY_CTRL_UP			KEY_CTRL_PAGEUP		KEY_CTRL_UP
\/	KEY_CTRL_DOWN		KEY_CTRL_PAGEDOWN	KEY_CTRL_DOWN
->	KEY_CTRL_LEFT		KEY_CTRL_LEFT
<-	KEY_CTRL_RIGHT		KEY_CTRL_RIGHT
F1	KEY_CTRL_F1			KEY_CTRL_F1			KEY_CTRL_F1
F2	KEY_CTRL_F2			KEY_CTRL_F2			KEY_CTRL_F2
F3	KEY_CTRL_F3			KEY_CTRL_F3			KEY_CTRL_F3
F4	KEY_CTRL_F4			KEY_CTRL_F4			KEY_CTRL_F4
F5	KEY_CTRL_F5			KEY_CTRL_F5			KEY_CTRL_F5
F6	KEY_CTRL_F6			KEY_CTRL_F6			KEY_CTRL_F6
*/

/*
KEY_CHAR_STORE							KEY_CHAR_L
KEY_CHAR_EXP		KEY_CHAR_PI			KEY_CHAR_DQUATE
KEY_CHAR_LPAR		KEY_CHAR_CUBEROOT	KEY_CHAR_I
KEY_CHAR_RPAR		KEY_CHAR_RECIP		KEY_CHAR_J
KEY_CHAR_COMMA							KEY_CHAR_K
KEY_CHAR_DP			KEY_CHAR_EQUAL		KEY_CHAR_SPACE
KEY_CHAR_0			KEY_CHAR_IMGNRY		KEY_CHAR_Z
KEY_CHAR_1			KEY_CHAR_LIST		KEY_CHAR_U
KEY_CHAR_2			KEY_CHAR_MAT		KEY_CHAR_V
KEY_CHAR_3								KEY_CHAR_W
KEY_CHAR_4			KEY_CTRL_CATALOG	KEY_CHAR_P
KEY_CHAR_5								KEY_CHAR_Q
KEY_CHAR_6								KEY_CHAR_R
KEY_CHAR_7			KEY_CTRL_CAPTURE	KEY_CHAR_M
KEY_CHAR_8			KEY_CTRL_CLIP		KEY_CHAR_N
KEY_CHAR_9			KEY_CTRL_PASTE		KEY_CHAR_O
KEY_CHAR_SIN		KEY_CHAR_ASIN		KEY_CHAR_D
KEY_CHAR_COS		KEY_CHAR_ACOS		KEY_CHAR_E
KEY_CHAR_TAN		KEY_CHAR_ATAN		KEY_CHAR_F
KEY_CHAR_LN			KEY_CHAR_EXPN		KEY_CHAR_C
KEY_CHAR_PMINUS		KEY_CHAR_ANS
KEY_CHAR_PLUS		KEY_CHAR_LBRCKT		KEY_CHAR_X
KEY_CHAR_SQUARE		KEY_CHAR_ROOT		KEY_CHAR_VALR
KEY_CHAR_LOG		KEY_CHAR_EXPN10		KEY_CHAR_B
KEY_CHAR_MINUS		KEY_CHAR_RBRCKT		KEY_CHAR_Y
KEY_CHAR_POW		KEY_CHAR_POWROOT	KEY_CHAR_THETA
KEY_CHAR_MULT		KEY_CHAR_LBRACE		KEY_CHAR_S
KEY_CHAR_DIV		KEY_CHAR_RBRACE		KEY_CHAR_T
KEY_CHAR_FRAC		KEY_CTRL_MIXEDFRAC	KEY_CHAR_G

KEY_CTRL_XTT		KEY_CHAR_ANGLE		KEY_CHAR_A
KEY_CTRL_EXIT		KEY_CTRL_QUIT		KEY_CTRL_EXIT
KEY_CTRL_MENU		KEY_CTRL_SETUP
KEY_CTRL_EXE		KEY_CHAR_CR
KEY_CTRL_SHIFT		KEY_CTRL_SHIFT		KEY_CTRL_SHIFT
KEY_CTRL_ALPHA		KEY_CTRL_ALPHA		KEY_CTRL_ALPHA
KEY_CTRL_OPTN
KEY_CTRL_F1			KEY_CTRL_F1			KEY_CTRL_F1
KEY_CTRL_F2			KEY_CTRL_F2			KEY_CTRL_F2
KEY_CTRL_F3			KEY_CTRL_F3			KEY_CTRL_F3
KEY_CTRL_F4			KEY_CTRL_F4			KEY_CTRL_F4
KEY_CTRL_F5			KEY_CTRL_F5			KEY_CTRL_F5
KEY_CTRL_F6			KEY_CTRL_F6			KEY_CTRL_F6
KEY_CTRL_AC
KEY_CTRL_VARS		KEY_CTRL_PRGM
KEY_CTRL_UP			KEY_CTRL_PAGEUP		KEY_CTRL_UP
KEY_CTRL_LEFT							KEY_CTRL_LEFT
KEY_CTRL_RIGHT							KEY_CTRL_RIGHT
KEY_CTRL_DOWN		KEY_CTRL_PAGEDOWN	KEY_CTRL_DOWN
KEY_CTRL_DEL		KEY_CTRL_INS
KEY_CTRL_FD			KEY_CTRL_FRACCNVRT	KEY_CHAR_H
*/

/*
KEY_CTRL_EXE		KEY_CHAR_CR
KEY_CHAR_DP			KEY_CHAR_EQUAL		KEY_CHAR_SPACE
KEY_CHAR_PLUS		KEY_CHAR_LBRCKT		KEY_CHAR_X
KEY_CHAR_MINUS		KEY_CHAR_RBRCKT		KEY_CHAR_Y
KEY_CHAR_SQUARE		KEY_CHAR_ROOT		KEY_CHAR_VALR
KEY_CHAR_LN			KEY_CHAR_EXPN		KEY_CHAR_C
KEY_CHAR_LOG		KEY_CHAR_EXPN10		KEY_CHAR_B
KEY_CHAR_POW		KEY_CHAR_POWROOT	KEY_CHAR_THETA
KEY_CHAR_PMINUS		KEY_CHAR_ANS
KEY_CHAR_MULT		KEY_CHAR_LBRACE		KEY_CHAR_S
KEY_CHAR_DIV		KEY_CHAR_RBRACE		KEY_CHAR_T
KEY_CHAR_SIN		KEY_CHAR_ASIN		KEY_CHAR_D
KEY_CHAR_COS		KEY_CHAR_ACOS		KEY_CHAR_E
KEY_CHAR_TAN		KEY_CHAR_ATAN		KEY_CHAR_F
KEY_CHAR_LPAR		KEY_CHAR_CUBEROOT	KEY_CHAR_I
KEY_CHAR_RPAR		KEY_CHAR_RECIP		KEY_CHAR_J
KEY_CHAR_EXP		KEY_CHAR_PI			KEY_CHAR_DQUATE

KEY_CHAR_2			KEY_CHAR_MAT		KEY_CHAR_V
KEY_CHAR_0			KEY_CHAR_IMGNRY		KEY_CHAR_Z
KEY_CHAR_1			KEY_CHAR_LIST		KEY_CHAR_U
KEY_CTRL_XTT		KEY_CHAR_ANGLE		KEY_CHAR_A

KEY_CTRL_SHIFT		KEY_CTRL_SHIFT		KEY_CTRL_SHIFT
KEY_CTRL_ALPHA		KEY_CTRL_ALPHA		KEY_CTRL_ALPHA
KEY_CTRL_F1			KEY_CTRL_F1			KEY_CTRL_F1
KEY_CTRL_F2			KEY_CTRL_F2			KEY_CTRL_F2
KEY_CTRL_F3			KEY_CTRL_F3			KEY_CTRL_F3
KEY_CTRL_F4			KEY_CTRL_F4			KEY_CTRL_F4
KEY_CTRL_F5			KEY_CTRL_F5			KEY_CTRL_F5
KEY_CTRL_F6			KEY_CTRL_F6			KEY_CTRL_F6
KEY_CTRL_FD			KEY_CTRL_FRACCNVRT	KEY_CHAR_H
KEY_CTRL_VARS		KEY_CTRL_PRGM
KEY_CTRL_EXIT		KEY_CTRL_QUIT		KEY_CTRL_EXIT
KEY_CTRL_DEL		KEY_CTRL_INS
KEY_CHAR_9			KEY_CTRL_PASTE		KEY_CHAR_O
KEY_CTRL_MENU		KEY_CTRL_SETUP
KEY_CHAR_8			KEY_CTRL_CLIP		KEY_CHAR_N
KEY_CTRL_UP			KEY_CTRL_PAGEUP		KEY_CTRL_UP
KEY_CTRL_DOWN		KEY_CTRL_PAGEDOWN	KEY_CTRL_DOWN
KEY_CHAR_FRAC		KEY_CTRL_MIXEDFRAC	KEY_CHAR_G
KEY_CHAR_7			KEY_CTRL_CAPTURE	KEY_CHAR_M
KEY_CHAR_4			KEY_CTRL_CATALOG	KEY_CHAR_P
*/

/*
KEY_CHAR_DP			KEY_CHAR_EQUAL		KEY_CHAR_SPACE
KEY_CHAR_EXP		KEY_CHAR_PI			KEY_CHAR_DQUATE
KEY_CHAR_SQUARE		KEY_CHAR_ROOT		KEY_CHAR_VALR
KEY_CHAR_POW		KEY_CHAR_POWROOT	KEY_CHAR_THETA
KEY_CTRL_XTT		KEY_CHAR_ANGLE		KEY_CHAR_A
KEY_CHAR_LOG		KEY_CHAR_EXPN10		KEY_CHAR_B
KEY_CHAR_LN			KEY_CHAR_EXPN		KEY_CHAR_C
KEY_CHAR_SIN		KEY_CHAR_ASIN		KEY_CHAR_D
KEY_CHAR_COS		KEY_CHAR_ACOS		KEY_CHAR_E
KEY_CHAR_TAN		KEY_CHAR_ATAN		KEY_CHAR_F
KEY_CHAR_FRAC		KEY_CTRL_MIXEDFRAC	KEY_CHAR_G
KEY_CTRL_FD			KEY_CTRL_FRACCNVRT	KEY_CHAR_H
KEY_CHAR_LPAR		KEY_CHAR_CUBEROOT	KEY_CHAR_I
KEY_CHAR_RPAR		KEY_CHAR_RECIP		KEY_CHAR_J
KEY_CHAR_COMMA							KEY_CHAR_K
KEY_CHAR_STORE							KEY_CHAR_L
KEY_CHAR_7			KEY_CTRL_CAPTURE	KEY_CHAR_M
KEY_CHAR_8			KEY_CTRL_CLIP		KEY_CHAR_N
KEY_CHAR_9			KEY_CTRL_PASTE		KEY_CHAR_O
KEY_CHAR_4			KEY_CTRL_CATALOG	KEY_CHAR_P
KEY_CHAR_5								KEY_CHAR_Q
KEY_CHAR_6								KEY_CHAR_R
KEY_CHAR_MULT		KEY_CHAR_LBRACE		KEY_CHAR_S
KEY_CHAR_DIV		KEY_CHAR_RBRACE		KEY_CHAR_T
KEY_CHAR_1			KEY_CHAR_LIST		KEY_CHAR_U
KEY_CHAR_2			KEY_CHAR_MAT		KEY_CHAR_V
KEY_CHAR_3								KEY_CHAR_W
KEY_CHAR_PLUS		KEY_CHAR_LBRCKT		KEY_CHAR_X
KEY_CHAR_MINUS		KEY_CHAR_RBRCKT		KEY_CHAR_Y
KEY_CHAR_0			KEY_CHAR_IMGNRY		KEY_CHAR_Z

KEY_CTRL_EXIT		KEY_CTRL_QUIT		KEY_CTRL_EXIT
KEY_CTRL_SHIFT		KEY_CTRL_SHIFT		KEY_CTRL_SHIFT
KEY_CTRL_ALPHA		KEY_CTRL_ALPHA		KEY_CTRL_ALPHA
KEY_CTRL_F1			KEY_CTRL_F1			KEY_CTRL_F1
KEY_CTRL_F2			KEY_CTRL_F2			KEY_CTRL_F2
KEY_CTRL_F3			KEY_CTRL_F3			KEY_CTRL_F3
KEY_CTRL_F4			KEY_CTRL_F4			KEY_CTRL_F4
KEY_CTRL_F5			KEY_CTRL_F5			KEY_CTRL_F5
KEY_CTRL_F6			KEY_CTRL_F6			KEY_CTRL_F6
KEY_CTRL_UP			KEY_CTRL_PAGEUP		KEY_CTRL_UP
KEY_CTRL_LEFT							KEY_CTRL_LEFT
KEY_CTRL_RIGHT							KEY_CTRL_RIGHT
KEY_CTRL_DOWN		KEY_CTRL_PAGEDOWN	KEY_CTRL_DOWN
*/

/*
KEY_CHAR_MAT
15
KEY_CHAR_IMGNRY
KEY_CHAR_LIST
3
KEY_CHAR_ANGLE

KEY_CTRL_XTT
KEY_CTRL_EXIT
KEY_CTRL_MENU
KEY_CTRL_EXE
1
KEY_CTRL_SHIFT
KEY_CTRL_ALPHA
KEY_CTRL_OPTN
KEY_CTRL_F1	
KEY_CTRL_F2	
KEY_CTRL_F3	
KEY_CTRL_F4	
KEY_CTRL_F5	
KEY_CTRL_F6	
KEY_CTRL_AC
KEY_CTRL_VARS
1
KEY_CTRL_UP
1
KEY_CTRL_LEFT
KEY_CTRL_RIGHT
1
KEY_CTRL_DOWN
1
KEY_CTRL_DEL
KEY_CTRL_FRACCNVRT
1
KEY_CTRL_PRGM
KEY_CTRL_QUIT
3
KEY_CTRL_INS
2
KEY_CTRL_PASTE
KEY_CTRL_SETUP
8
KEY_CTRL_FD	
3
KEY_CTRL_CLIP
1
KEY_CTRL_PAGEUP	
KEY_CTRL_PAGEDOWN
KEY_CTRL_MIXEDFRAC
KEY_CTRL_CAPTURE
44
KEY_CTRL_CATALOG
*/