#ifndef GETKEYS
#define GETKEYS

#include <stdio.h>
#include <keybios.h>
#include "Syscall.h"

#define GET_KEY
#define GETKEY_NB
// #define KEY_ENCODE
// #define KEY_DECODE
// #define KEY_ENCODE_OLD

#ifndef _Bool
#define _Bool
	typedef enum { FALSE, TRUE } Bool;
#endif

unsigned int KeyEncode(int kcode1, int kcode2);
// int Bkey_GetKeyWait(int* kcode1, int* kcode2, int wait_type, int seconds, Bool menu, short* unused);

#define KeyDown(col, row) scanKeyboard(col - 1, row)
#define IsKeyDown(key) KeyDown(((key) / 10), (key) % 10)
#define KeyUp(col, row) !KeyDown(col, row)
#define IsKeyUp(key) !IsKeyDown(key)

/*
	+	70,			60,			50,			40,			30,			20,			10
	9	KEY_F1,		KEY_F2,		KEY_F3,		KEY_F4,		KEY_F5,		KEY_F6,		KEY_NOP,
	8	KEY_SHIFT,	KEY_OPTN,	KEY_VARS,	KEY_MENU,	KEY_LEFT,	KEY_UP,		KEY_NOP,
	7	KEY_ALPHA,	KEY_SQUARE,	KEY_POW,	KEY_EXIT,	KEY_DOWN,	KEY_RIGHT,	KEY_NOP,
	6	KEY_XTT,	KEY_LOG,	KEY_LN,		KEY_SIN,	KEY_COS,	KEY_TAN,	KEY_NOP,
	5	KEY_FRAC,	KEY_FD,		KEY_LPAR,	KEY_RPAR,	KEY_COMMA,	KEY_STORE,	KEY_NOP,
	4	KEY_7,		KEY_8,		KEY_9,		KEY_DEL,	KEY_NOP,	KEY_NOP,	KEY_NOP,
	3	KEY_4,		KEY_5,		KEY_6,		KEY_MULT,	KEY_DIV,	KEY_NOP,	KEY_NOP,
	2	KEY_1,		KEY_2,		KEY_3,		KEY_PLUS,	KEY_MINUS,	KEY_NOP,	KEY_NOP,
	1	KEY_0,		KEY_DP,		KEY_EXP,	KEY_PMINUS,	KEY_EXE,	KEY_NOP,	KEY_NOP,
	0	KEY_NOP,	KEY_NOP,	KEY_NOP,	KEY_NOP,	KEY_NOP,	KEY_NOP,	KEY_AC,
*/

#define KEY_F1		79
#define KEY_F2		69
#define KEY_F3		59
#define KEY_F4		49
#define KEY_F5		39
#define KEY_F6		29

#define KEY_SHIFT	78
#define KEY_OPTN	68
#define KEY_VARS	58
#define KEY_MENU	48
#define KEY_LEFT	38
#define KEY_UP		28

#define KEY_ALPHA	77
#define KEY_SQUARE	67
#define KEY_POW		57
#define KEY_EXIT	47
#define KEY_DOWN	37
#define KEY_RIGHT	27

#define KEY_XTT		76
#define KEY_LOG		66
#define KEY_LN		56
#define KEY_SIN		46
#define KEY_COS		36
#define KEY_TAN		26

#define KEY_FRAC	75
#define KEY_FD		65
#define KEY_LPAR	55
#define KEY_RPAR	45
#define KEY_COMMA	35
#define KEY_STORE	25

#define KEY_7		74
#define KEY_8		64
#define KEY_9		54
#define KEY_DEL		44

#define KEY_4		73
#define KEY_5		63
#define KEY_6		53
#define KEY_MULT	43
#define KEY_DIV		33

#define KEY_1		72
#define KEY_2		62
#define KEY_3		52
#define KEY_PLUS	42
#define KEY_MINUS	32

#define KEY_0		71
#define KEY_DP		61
#define KEY_EXP		51
#define KEY_PMINUS	41
#define KEY_EXE		31

#define KEY_AC		10

#define KEY_NOP		0


#define KEY_PRGM		KEY_VARS
#define KEY_SETUP		KEY_MENU
#define KEY_PAGEUP		KEY_UP

#define KEY_ROOT		KEY_SQUARE
#define KEY_POWROOT		KEY_POW
#define KEY_QUIT		KEY_EXIT
#define KEY_PAGEDOWN	KEY_DOWN

#define KEY_ANGLE		KEY_XTT
#define KEY_EXPN10		KEY_LOG
#define KEY_EXPN		KEY_LN
#define KEY_ASIN		KEY_SIN
#define KEY_ACOS		KEY_COS
#define KEY_ATAN		KEY_TAN

#define KEY_MIXEDFRAC	KEY_FRAC
#define KEY_FRACCNVRT	KEY_FD
#define KEY_CUBEROOT	KEY_LPAR
#define KEY_RECIP		KEY_RPAR
#define KEY_K			KEY_COMMA
#define KEY_L			KEY_STORE

#define KEY_CAPTURE		KEY_7
#define KEY_CLIP		KEY_8
#define KEY_PASTE		KEY_9
#define KEY_INS			KEY_DEL

#define KEY_CATALOG		KEY_4
#define KEY_Q			KEY_5
#define KEY_R			KEY_6
#define KEY_LBRACE		KEY_MULT
#define KEY_RBRACE		KEY_DIV

#define KEY_LIST		KEY_1
#define KEY_MAT			KEY_2
#define KEY_W			KEY_3
#define KEY_LBRCKT		KEY_PLUS
#define KEY_RBRCKT		KEY_MINUS

#define KEY_IMGNRY		KEY_0
#define KEY_EQUAL		KEY_DP
#define KEY_PI			KEY_EXP
#define KEY_ANS			KEY_PMINUS
#define KEY_CR			KEY_EXE


#define KEY_VALR	KEY_SQUARE
#define KEY_THETA	KEY_POW

#define KEY_A		KEY_XTT
#define KEY_B		KEY_LOG
#define KEY_C		KEY_LN
#define KEY_D		KEY_SIN
#define KEY_E		KEY_COS
#define KEY_F		KEY_TAN

#define KEY_G		KEY_FRAC
#define KEY_H		KEY_FD
#define KEY_I		KEY_LPAR
#define KEY_J		KEY_RPAR
#define KEY_K		KEY_COMMA
#define KEY_L		KEY_STORE

#define KEY_M		KEY_7
#define KEY_N		KEY_8
#define KEY_O		KEY_9

#define KEY_P		KEY_4
#define KEY_Q		KEY_5
#define KEY_R		KEY_6
#define KEY_S		KEY_MULT
#define KEY_T		KEY_DIV

#define KEY_U		KEY_1
#define KEY_V		KEY_2
#define KEY_W		KEY_3
#define KEY_X		KEY_PLUS
#define KEY_Y		KEY_MINUS

#define KEY_Z		KEY_0
#define KEY_SPACE	KEY_DP
#define KEY_DQUATE	KEY_EXP

#endif // GETKEYS