#include "Deghost.h"

int amountBlackH = 4;
int amountWhiteH = 10;
int amountBlackV = 4;
int amountWhiteV = 13;

void move(int *x, int *y, int direction)
{
	switch (direction)
	{
	case RIGHT:
		*x += 1;
		break;
	case DOWN:
		*y += 1;
		break;
	case LEFT:
		*x -= 1;
		break;
	case UP:
		*y -= 1;
		break;
	}
	*x &= 0x7F;
	*y &= 0x3F;
}

void RenderRectangle(x, y, direction)
{
	int i, j, k, l;
	unsigned char byte, pixel;
	// char ScreenGrayShades[64][128] = {0};
	char *vram = ML_vram_address();
	char PredictedMap_Buffer[16][64][16] = {1};
	int amountBlack = (direction == UP || direction == DOWN) ? amountBlackV : amountBlackH;
	int amountWhite = (direction == UP || direction == DOWN) ? amountWhiteV : amountWhiteH;

	for (i = 0; i < MAX(MAX(MAX(amountBlackH, amountWhiteH), amountBlackV), amountWhiteV); i++)
	{
		ML_clear_vram();
		move(&x, &y, direction);
		ML_rectangle_wrap(x, y, x + 64, y + 32, ML_BLACK);
		memcpy(PredictedMap_Buffer[i], vram, 1024);
	}
	for (j = 0; j < 64; j++)
	{
		for (i = 0; i < 16; i++)
		{
			for (l = 0; l < 8; l++)
			{
				pixel = (PredictedMap_Buffer[0][j][i] >> (7 - l)) & 1;
				for (k = 1; k < (pixel ? amountWhite : amountBlack); k++)
				// for (k = 1; k < amountBlackH; k++)
				{
					// byte = (byte << 1) | (((ScreenGrayShades[j][i] >> (7 - k)) & 1) > 0);
					if (pixel != ((PredictedMap_Buffer[k][j][i] >> (7 - l)) & 1))
					{
						pixel = !pixel;
						break;
					}
				}
				byte = (byte << 1) | pixel;
			}
			*vram++ = byte;
		}
	}
	// memcpy(ML_vram_address(), PredictedMap_Buffer[1], 1024);
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int x = 32, y = 16, i, j, temp = 0;
	int direction;
	unsigned int key;
	unsigned int ticks = RTC_GetTicks();
	/* 	const unsigned short Rectange[16] = {
		0xFFFF, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0x8001, 0xFFFF
	}; */

	while (TRUE)
	{
		while (IsKeyUp(KEY_MENU) && IsKeyUp(KEY_EXIT))
		{
			while (RTC_GetTicks() - 2 < ticks)
				Sleep(0);
			ticks = RTC_GetTicks();

			if (IsKeyUp(KEY_PLUS) && IsKeyUp(KEY_MINUS) && IsKeyUp(KEY_MULT) && IsKeyUp(KEY_DIV))
				key = 0;
			if (key != KEY_PLUS && IsKeyDown(KEY_PLUS))
			{
				if (direction == UP || direction == DOWN)
				{
					if (amountBlackV < 16)
						amountBlackV++;
				}
				else
				{
					if (amountBlackH < 16)
						amountBlackH++;
				}
					key = KEY_PLUS;
			}
			if (key != KEY_MINUS && IsKeyDown(KEY_MINUS))
			{
				if (direction == UP || direction == DOWN)
				{
					if (amountBlackV >2)
						amountBlackV--;
				}
				else
				{
					if (amountBlackH > 2)
						amountBlackH--;
				}
				key = KEY_MINUS;
			}
			if (key != KEY_MULT && IsKeyDown(KEY_MULT))
			{
				if (direction == UP || direction == DOWN)
				{
					if (amountWhiteV < 16)
						amountWhiteV++;
				}
				else
				{
					if (amountWhiteH < 16)
						amountWhiteH++;
				}
				key = KEY_MULT;
			}
			if (key != KEY_DIV && IsKeyDown(KEY_DIV))
			{
				if (direction == UP || direction == DOWN)
				{
					if (amountWhiteV > 2)
						amountWhiteV--;
				}
				else
				{
					if (amountWhiteH > 2)
						amountWhiteH--;
				}
				key = KEY_DIV;
			}

			if (IsKeyDown(KEY_RIGHT))
				direction = RIGHT;
			if (IsKeyDown(KEY_DOWN))
				direction = DOWN;
			if (IsKeyDown(KEY_LEFT))
				direction = LEFT;
			if (IsKeyDown(KEY_UP))
				direction = UP;
			if (IsKeyDown(KEY_EXE))
				direction = -1;
			move(&x, &y, direction);

			RenderRectangle(x, y, direction);
			ML_display_vram();
		}
		while(IsKeyDown(KEY_MENU) || IsKeyDown(KEY_EXIT));
		Keyboard_ClrBuffer();
		GetKey(&key);
	}
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
	return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section